#include <shotFGL.h>
#include <boxFGL.h>
#include <par.h>
#include <experimentFGL.h>
#include <GL/freeglut.h>
#include <iostream>

using namespace std;

Par par("ini/par.ini");

ShotFGL shot("ini/shot.ini", "ini/shotGL.ini");
BoxFGL box("ini/box.ini", "ini/boxGL.ini");
ExperimentFGL experiment(shot, box, par, "ini/parGL.ini");

void idle()
    {experiment.idleCallback();}
void display()
    {experiment.displayCallback();}
void keyboard(unsigned char key, int x, int y)
    {experiment.keyboardCallback(key, x, y);}
void special(int key, int x, int y)
    {experiment.specialCallback(key, x, y);}
void mouse(int button, int state, int x, int y)
    {experiment.mouseCallback(button, state, x, y);}
void motion(int x, int y)
    {experiment.motionCallback(x, y);}
void reshape(int width, int height)
    {experiment.reshapeCallback(width, height);}

int
main(int argc, char *argv[])
{
    experiment.initFGL(argc, argv);
    glutIdleFunc(idle);
    glutDisplayFunc(display);
    glutKeyboardFunc(keyboard);
    glutSpecialFunc(special);
    glutMouseFunc(mouse);
    glutMotionFunc(motion);
    glutReshapeFunc(reshape);

    glutMainLoop();
//    system("PAUSE");
    return EXIT_SUCCESS;
}

