#ifndef _CHAMBER_H_
#define _CHAMBER_H_

class Chamber
{
public:
    virtual ~Chamber() {}

    virtual double radius() const = 0;
    virtual double gravity() const = 0;
    
    virtual void useSphereDiameter(double diam) = 0;
    
    virtual double level(double volume) const = 0;

    virtual int isInside(const double *r) const = 0;
    virtual int isOutside(const double *r) const = 0;

    virtual void advance(double time) = 0;
    virtual double detect(const double *r, const double *v, double best_time) = 0;
    virtual void collide(const double *r, double *v) = 0;
    
    virtual void reset() = 0;
};

#endif

