#include "cylinderFGL.h"
#include <GL/freeglut.h>
#include <iostream>
#include <fstream>

using namespace std;

CylinderFGL::~CylinderFGL()
{
}

CylinderFGL::CylinderFGL(const char* ini, const char* iniGL)
    : Cylinder(ini)
{
    ifstream is(iniGL);
    if(!is.is_open()) {cerr <<"Error reading "<< iniGL << endl; exit(1);}
    is >> GLdetail_; while(is.get()!='\n');
    
    is >> GLslices_; while(is.get()!='\n');
    if(height0_) GLspacing_= height0_/GLslices_;
    else         GLspacing_= radius0_ * .2;

    is >> GLbaseR_ >> GLbaseG_ >> GLbaseB_ >> GLbaseA_; while(is.get()!='\n');
    is >> GLwallR_ >> GLwallG_ >> GLwallB_ >> GLwallA_; while(is.get()!='\n');
    if(!is) {cerr <<"Error reading "<< iniGL << endl; exit(1);}
}

void
CylinderFGL::draw() const
{
    glEnable(GL_BLEND);
    glDisable(GL_DEPTH_TEST);

// DRAW CYLINDER WALL (transparent)
    glColor4f(GLwallR_, GLwallG_, GLwallB_, GLwallA_);
    glutSolidCylinder(radius0_, GLspacing_*GLslices_, GLdetail_, 1);

    glDisable(GL_BLEND);
    glEnable(GL_DEPTH_TEST);

    glColor4f(GLbaseR_, GLbaseG_, GLbaseB_, GLbaseA_);

// DRAW LID RIM
    if(height0_) {
        glTranslatef(0., 0., height0_);
        glutSolidTorus(.1,radius0_,3,GLdetail_);
        glTranslatef(0., 0., -height0_);
    }

// DRAW MOVING BASE
    double thickness= .1;
    glTranslatef(0., 0., base_z_-thickness);
    glutSolidCylinder(radius0_, thickness, GLdetail_, 1);
    glTranslatef(0., 0., -base_z_+thickness);
}

void
CylinderFGL::console()
{
}

