#include "experiment.h"

class ExperimentFGL : public Experiment {
public:
    ~ExperimentFGL();
    ExperimentFGL(Shot&, Chamber&, const Par&, const char* iniFGL);
    
    void initFGL(int argc, char** argv) const;
    
    void idleCallback();
    void displayCallback();
    void mouseCallback(int button, int state, int x, int y);
    void keyboardCallback(unsigned char key, int x, int y);
    void specialCallback(int key, int x, int y);
    void motionCallback(int x, int y);
    void reshapeCallback(int width, int height);

private:
    void showText();
    int GLx_prev_, GLy_prev_;// mouse coordinate in window
    int GLb_left_, GLb_right_;// mouse buttons
    
    int GLspeed_;// drawing speed
    double GLtstep_;// drawing interval

    double GLdistance_min_, GLdistance_max_, GLdistance_;// camera distance
    double GLztarget_;// position of camera target on axis
    int GLtheta_, GLphi_;// viewing angles
};
