#include "experimentStats3D.h"
#include <iostream>

ExperimentStats3D::~ExperimentStats3D()
{
    stats3D_.dump(shot_);
}

ExperimentStats3D::ExperimentStats3D
        (Shot& shot, Chamber& chamber, Stats3D& stats3D, const Par& par)
    : Experiment(shot, chamber, par)
    , stats3D_(stats3D)
{
}

void
ExperimentStats3D::fullRun()
{
    cout << "Computing "<< ncolmax_ <<" collisions / "<< tmax_ <<" cycles..."<<endl;
    cout << "Calculating statistics every "<< tstep_ <<" cycles..."<<endl;
    Timer timer("cpu");
    while(collisions_<ncolmax_ || tfull_<tmax_) {
        makeStep(tstep_);
        stats3D_.makeEntry(shot_);
        cout <<collisions_ <<" of "<< ncolmax_<<" collisions / "
            << tfull_<<" of "<<tmax_<<" cycles"<<endl;
    }
    cout << collisions_ <<" collisions computed in "<< timer <<" seconds"<< endl;
}
