#include "shotFGL.h"
#include "xyz.h"
#include <GL/freeglut.h>
#include <iostream>
#include <fstream>

using namespace std;

ShotFGL::~ShotFGL()
{
}

ShotFGL::ShotFGL(const char* ini, const char* iniGL)
    : Shot(ini)
{
    ifstream is(iniGL);
    if(!is.is_open()) {cerr <<"Error reading "<< iniGL << endl; exit(1);}
    is >> GLdetail_; while(is.get()!='\n'); GLdetail2_= 2*GLdetail_;
    is >> GLheight_; while(is.get()!='\n');
    is >> GLbotR_ >> GLbotG_ >> GLbotB_; while(is.get()!='\n');
    is >> GLtopR_ >> GLtopG_ >> GLtopB_; while(is.get()!='\n');
    is >> GLmarkR_ >> GLmarkG_ >> GLmarkB_; while(is.get()!='\n');
    if(!is) {cerr <<"Error reading "<< iniGL << endl; exit(1);}
}

void
ShotFGL::draw() const
{
    for(int i=0;  i<n_; ++i) {
        double *ri= r_[i];
        double h = ri[Z] / GLheight_;
        double
            r= GLbotR_ + (GLtopR_ - GLbotR_)*h,
            g= GLbotG_ + (GLtopG_ - GLbotG_)*h,
            b= GLbotB_ + (GLtopB_ - GLbotB_)*h;
        h>1 ? glColor4f(GLtopR_, GLtopG_, GLtopB_, 1.)
            : glColor4f(r, g, b, 1.);

        if (i==0) glColor4f(GLmarkR_, GLmarkG_, GLmarkB_,1.);
        glTranslatef(ri[X], ri[Y], ri[Z] + radius_);
        glutSolidSphere(radius_, GLdetail2_, GLdetail_);
        glTranslatef(-ri[X], -ri[Y], -ri[Z] -radius_);
    }
}

void
ShotFGL::console()
{
}
