#ifndef _STATS_H_
#define _STATS_H_

#include <fstream>

using namespace std;

class Stats2Dr {
public:
    ~Stats2Dr();
    Stats2Dr();
    Stats2Dr(const double*);

    void setCells(int cells, double radius);
    void setNormal(const double*);
    void reset();
    void hit(const double* r, const double* v_before, const double* v_after);

    void dump(const char*) const;
    void dump(ofstream&) const;
private:
    void rescale();
    int cells_;
    int hits_;
    int *hist_;
    double *pressure_;
    double *energy_;
    double scale_, scale_inv_;
    double normal_[3];// normal vector
};

class Stats2Dxy {
public:
    ~Stats2Dxy();
    Stats2Dxy();
    Stats2Dxy(const double*);

    void setCells(int xcells, int ycells, double xsize, double ysize);
    void setNormal(const double*);
    void reset();
    void hit(const double* r, const double* v_before, const double* v_after);

    void dump(const char*) const;
    void dump(ofstream&) const;
    void dumpZone(const char*) const;
    void dumpZone(ofstream&) const;
private:
    int xcells_, ycells_, cells_;
    int hits_;
    int *hist_;
    double *pressure_;
    double *energy_;
    double xscale_, xscale_inv_, yscale_, yscale_inv_;
    double normal_[3];// normal vector
};

#endif
