#ifndef _STATS3D_H_
#define _STATS3D_H_

#include <fstream>

class Shot;

//------------------------------------------------------------------------------
class Stats3D {
public:
    virtual ~Stats3D() {}
    
    virtual void reset() = 0;
/*
    virtual void newEntry() = 0;
    virtual void hit(const double* r, const double* v) = 0;
*/
    virtual void makeEntry(const Shot&) = 0;

    virtual void dump(const Shot&) const = 0;
};

class Stats3Drz : public Stats3D {
public:
    virtual ~Stats3Drz();
    Stats3Drz() {}
    Stats3Drz(const char* filename);
    
// inherited Stats3D interface
    void reset();
    void makeEntry(const Shot&);

    void dump(const Shot&) const;

private:
    void rescale();
    
    int rcells_, zcells_, cells_;
    int entries_;
    double rscale_, rscale_inv_, zscale_, zscale_inv_;
    int *n_;// density
    double *vr_, *vz_, *vt_;// velocity
    double *kr_, *kz_, *kt_;// energy
};

//------------------------------------------------------------------------------
class Stats3Dxyz : public Stats3D {
public:
    ~Stats3Dxyz();
    Stats3Dxyz() {}
    Stats3Dxyz(const char* filename);

// inherited Stats3D interface
    void reset();
/*
    void newEntry();
    void hit(const double* r, const double* v);
*/
    void makeEntry(const Shot&);

    void dump() const;

private:
    int xcells_, ycells_, zcells_, cells_;
    int entries_;
    int *hist_;
    double xscale_, xscale_inv_, yscale_, yscale_inv_, zscale_, zscale_inv_;
};

#endif
